<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: chart/CartesianChart.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: chart/CartesianChart.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2016 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['underscore', 'jquery', 'd3', 'ss', 'uweaver/lang', 'uweaver/dom', 'uweaver/widget/Widget',
    'uweaver/data/Collection', './axis/Axis', './series/ScatterSeries', './series/LineSeries',
    './series/BarSeries'], function(_, $, d3, ss, lang, dom, Widget, Collection, Axis, ScatterSeries, LineSeries, BarSeries) {

    var declare = lang.declare;
    var Base = Widget;

    var PADDING = 10, WIDTH = 400, HEIGHT = 300;

    /**
     * A CartesianChart visualizes its data points using the Cartesian coordinate system.
     *
     * ##### JavaScript
     * 
     *     var OrderCubes = declare(Collection, {
     *        resource: 'orderCubes',
     *        orderDate: function(options) {
     *            this.sync('orderDate', {before: new Date()}, options).then(function(response) {
     *                var items = this.parse(response);
     *                this.reset(items);
     *            }, this);
     *        },
     *        area: function(options) {
     *            this.sync('area', {}, options).then(function(response) {
     *                var items = this.parse(response);
     *                this.reset(items);
     *            }, this);
     *        },
     *        orderMonth: function(options) {
     *            this.sync('orderMonth', {}, options).then(function(response) {
     *                var items = this.parse(response);
     *                this.reset(items);
     *            }, this);
     *        },
     *     });

     *     var cubes = new OrderCubes();
     *     
     *     // Generate a temporal scatter chart.
     *     
     *     cubes.orderDate({async: false});
     *     
     *     var temporalScatterChart = new CartesianChart({
     *        el: '[name=temporalScatterChart]',
     *        data: cubes,
     *        //define the x and y-axis configuration.
     *        axes: [{
     *            type: CartesianChart.AXIS.NUMERICAL,
     *            position: CartesianChart.POSITION.LEFT,
     *            unit: 'USD'
     *        }, {
     *            type: CartesianChart.AXIS.TIME,
     *            position: CartesianChart.POSITION.BOTTOM,
     *            title: 'Order Date'
     *        }],
     *        title: "Daily Revenue &amp; Cost"
     *     }).render();
     *
     *     temporalScatterChart.addSeries({
     *          xField: 'orderDate',
     *          yField: 'cost',
     *          title: 'Cost'
     *     });
     *
     *     temporalScatterChart.addSeries({
     *          type: CartesianChart.SERIES.LINE,
     *          xField: 'orderDate',
     *          yField: 'amount',
     *          title: 'Revenue',
     *          tooltips: {
     *              renderer: function(item) {
     *                  return "Revenue in " + formatter.format(item.get('orderDate'), {pattern: "yyyy/MM"}) + ": " + formatter.format(item.get('amount'), {pattern: "$#,##0"});
     *              }
     *          }
     *      });
     *
     *      // draw a trendline
     *     temporalScatterChart.trendline('Revenue');
     *
     *     // draw a gridline
     *     temporalScatterChart.gridline(CartesianChart.POSITION.LEFT);
     *
     *     // draw a baseline
     *     temporalScatterChart.baseline({
     *          xField: 'orderDate',
     *          yField: 'goal',
     *          title: 'Goal'
     *      });
     * 
     *     // Generate a categorical bar chart.
     *     
     *     cubes.area({async: false});
     *     
     *     var categoricalBarChart = new CartesianChart({
     *        data: cubes,
     *        el: '[name=categoricalBarChart]',
     *        //define the x and y-axis configuration.
     *        axes: [{
     *            type: CartesianChart.AXIS.NUMERICAL,
     *            position: CartesianChart.POSITION.LEFT,
     *            unit: 'USD'
     *        }, {
     *            type: CartesianChart.AXIS.CATEGORICAL,
     *            position: CartesianChart.POSITION.BOTTOM,
     *            title: 'Area'
     *        }],
     *        //define the actual data series.
     *        series: [{
     *            type: CartesianChart.SERIES.BAR,
     *            xField: 'area',
     *            yField: 'amount',
     *            title: 'Revenue'
     *        }],
     *        width: 700, height: 400,
     *        title: "Revenue &amp; Cost by Area"
     *     }).render();
     *
     * 
     *      // Generate a temporal two y-axis bar chart.
     *      
     *     cubes.orderDate({async: false});
     *     var twoYAxisTemporalBarChart = new CartesianChart({
     *         data: cubes,
     *         el: '[name=TwoYAxisTemporalBarChart]',
     *         //define the x and y-axis configuration.
     *         axes: [{
     *             type: CartesianChart.AXIS.NUMERICAL,
     *             position: CartesianChart.POSITION.LEFT,
     *             unit: 'USD',
     *             title: 'Amount'
     *         }, {
     *             type: CartesianChart.AXIS.NUMERICAL,
     *             position: CartesianChart.POSITION.RIGHT,
     *             tickFormat: '#0.0%',
     *             title: 'Rate'
     *         }, {
     *             type: CartesianChart.AXIS.TIME,
     *             position: CartesianChart.POSITION.BOTTOM,
     *             title: 'Order Date'
     *         }],
     *         title: "Daily Revenue, Cost &amp; Margin"
     *     }).render();
     *     
     *     twoYAxisTemporalBarChart.addSeries({
     *         type: CartesianChart.SERIES.LINE,
     *         xField: 'orderDate',
     *         yField: 'margin',
     *         yAxis: CartesianChart.POSITION.RIGHT,
     *         title: 'Margin'
     *     });
     *     
     *     twoYAxisTemporalBarChart.addSeries({
     *         type: CartesianChart.SERIES.BAR,
     *         xField: 'orderDate',
     *         yField: 'amount',
     *         yAxis: CartesianChart.POSITION.LEFT,
     *         title: 'Cost'
     *     });
     *     
     *     twoYAxisTemporalBarChart.addSeries({
     *         type: CartesianChart.SERIES.BAR,
     *         xField: 'orderDate',
     *         yField: 'cost',
     *         yAxis: CartesianChart.POSITION.LEFT,
     *         title: 'Revenue'
     *     });
     *
     *      // Generate a temporal stacked bar chart.
     *      
     *     cubes.orderMonth({async: false});
     *     var StackedTemporalBarChart = new CartesianChart({
     *         data: cubes,
     *         el: '[name=StackedTemporalBarChart]',
     *         //define the x and y-axis configuration.
     *         axes: [{
     *             type: CartesianChart.AXIS.NUMERICAL,
     *             position: CartesianChart.POSITION.LEFT,
     *             unit: 'USD',
     *             title: 'Amount'
     *         }, {
     *             type: CartesianChart.AXIS.TIME,
     *             position: CartesianChart.POSITION.BOTTOM,
     *             title: 'Order Date',
     *             tickFormat: 'yyyy/MM'
     *         }],
     *         //define the actual data series.
     *         series: [{
     *             type: CartesianChart.SERIES.BAR,
     *             xField: 'orderDate',
     *             yField: ['north', 'south', 'east', 'west'],
     *             title: ['North', 'South', 'East', 'West'],
     *             tooltips: {
     *                  renderer: function(item, index) {
     *                      var yFields = ['north', 'south', 'east', 'west'];
     *                      var yField = yFields[index];
     *                      return "Revenue in " + formatter.format(item.get('orderDate'), {pattern: "yyyy/MM"}) + ": " + formatter.format(item.get(yField), {pattern: "$#,##0"});
     *                  }
     *              }
     *         }],
     *         title: "Revenue by Month"
     *     }).render();
     * 
     * ##### HTML
     *     &lt;svg name="TemporalScatterChart" style="width:700px;height:400px;">
     *     &lt;/svg>
     *      
     *     &lt;svg style="width:700px;height:400px;">
     *          &lt;g name="CategoricalBarChart">
     *          &lt;/g>
     *     &lt;/svg>
     *
     *     &lt;svg name="TwoYAxisTemporalBarChart" style="width:700px;height:400px;">
     *     &lt;/svg>
     *
     *     &lt;svg name="StackedTemporalBarChart" style="width:700px;height:400px;">
     *     &lt;/svg>
     *
     * #### JSON
     *     URL: orderCubes/orderDate
     *     Response:
     *     {
     *       "status" : 200,
     *       "items" : [{
     *           "amount": 1200,
     *           "cost": 800,
     *           "goal": 2000,
     *           "orderDate": "2015-03-04T00:00:00.000+0800"
     *       }, {
     *           "amount": 1500,
     *           "cost": 900,
     *           "orderDate": "2015-03-05T00:00:00.000+0800"
     *       }, {
     *           "amount": 800,
     *           "cost": 480,
     *           "orderDate": "2015-03-06T00:00:00.000+0800"
     *       }, {
     *           "amount": 2200,
     *           "cost": 1300,
     *           "orderDate": "2015-03-9T00:00:00.000+0800"
     *       }, {
     *           "amount": 800,
     *           "cost": 500,
     *           "orderDate": "2015-03-10T00:00:00.000+0800"
     *       }, {
     *           "amount": 1200,
     *           "cost": 860,
     *           "orderDate": "2015-03-11T00:00:00.000+0800"
     *       }, {
     *           "amount": 2300,
     *           "cost": 1430,
     *           "goal": 2000,
     *           "orderDate": "2015-03-12T00:00:00.000+0800"
     *       }]
     *     }
     *     
     *     URL: orderCubes/area
     *     Response: 
     *     {
     *       "status" : 200,
     *       "items" : [{
     *         "amount": 1200,
     *         "cost": 1000,
     *         "area": "north"
     *       }, {
     *           "amount": 800,
     *           "cost": 750,
     *           "area": "south"
     *       }, {
     *           "amount": 2200,
     *           "cost": 1800,
     *           "area": "east"
     *       }, {
     *           "amount": 2300,
     *           "cost": 1830,
     *           "area": "west"
     *       }]
     *     }
     *
     *     URL: orderCubes/orderMonth
     *     Response:
     *     {
     *       "status" : 200,
     *       "items" : [{
     *           "north": 21200,
     *           "east": 6800,
     *           "south": 4300,
     *           "west": 32000,
     *           "orderDate": "2015-03-01T00:00:00.000+0800"
     *       }, {
     *           "north": 41200,
     *           "east": 4800,
     *           "south": 7300,
     *           "west": 52000,
     *           "orderDate": "2015-04-01T00:00:00.000+0800"
     *       }, {
     *           "north": 21200,
     *           "east": 8500,
     *           "south": 7300,
     *           "west": 28000,
     *           "orderDate": "2015-05-01T00:00:00.000+0800"
     *       }, {
     *           "north": 31200,
     *           "east": 6800,
     *           "south": 4300,
     *           "west": 20800,
     *           "orderDate": "2015-06-01T00:00:00.000+0800"
     *       }, {
     *           "north": 41200,
     *           "east": 10800,
     *           "south": 8300,
     *           "west": 72000,
     *           "orderDate": "2015-07-01T00:00:00.000+0800"
     *       }, {
     *           "north": 41200,
     *           "east": 6800,
     *           "south": 9300,
     *           "west": 32000,
     *           "orderDate": "2015-09-01T00:00:00.000+0800"
     *       }, {
     *           "north": 41200,
     *           "east": 8000,
     *           "south": 7300,
     *           "west": 22000,
     *           "orderDate": "2015-10-01T00:00:00.000+0800"
     *       }, {
     *           "north": 11200,
     *           "east": 8020,
     *           "south": 3300,
     *           "west": 12000,
     *           "orderDate": "2015-11-01T00:00:00.000+0800"
     *       }, {
     *           "north": 12200,
     *           "east": 8000,
     *           "south": 3600,
     *           "west": 20300,
     *           "orderDate": "2015-12-01T00:00:00.000+0800"
     *       }, {
     *           "north": 21200,
     *           "east": 8800,
     *           "south": 9300,
     *           "west": 12000,
     *           "orderDate": "2015-01-01T00:00:00.000+0800"
     *       }, {
     *           "north": 30200,
     *           "east": 40000,
     *           "south": 10000,
     *           "west": 20200,
     *           "orderDate": "2015-02-01T00:00:00.000+0800"
     *       }]
     *     }
     * 
     * ##### Events:
     * + 'transition' - [data()]{@link CartesianChart#data}
     *
     * @constructor CartesianChart
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - A map of configuration to pass to the constructor.
     * @param {Collection} [config.data=new Collection()] - A collection to specify the models to display.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {
            style: {
            }
        };
        var cfg = this.cfg();

        _.defaults(cfg, defaults);

        this._component = d3.select(this.el);
        this._axes = {};
        this._series = [];
        this._anchors = {};

        this._color = d3.scale.category10();

        cfg.width &amp;&amp; this.width(cfg.width); cfg.height &amp;&amp; this.height(cfg.height);

        (cfg.data) ? this.data(cfg.data, {render: false}) : this.data(new Collection(), {render: false});

        this.css(cfg.style);

        var anchors = this._anchors;
        anchors.chart = this._component.append('g').attr('name', 'chart');
        anchors.canvas = anchors.chart.append('g').attr('name', 'canvas');
        anchors.title = anchors.chart.append('text').style({
            'font-size': '20px',
            'text-anchor': 'middle',
            'fill': this.color()
        }).attr('name', 'title');
        this.title(cfg.title);

        anchors.axes = [];

        _.each(cfg.axes, function(cfg) {
            var selection = anchors.chart.append('g');

            var axis = new Axis({
                el: selection.node(),
                type: cfg.type,
                position: cfg.position,
                tickFormat: cfg.tickFormat,
                title: cfg.title,
                unit: cfg.unit,
                style: {
                    'font-size': '12px',
                    stroke: this.color(),
                    fill: this.color()
                }
            });

            this._axes[cfg.position] = axis;
            anchors.axes[cfg.position] = selection;
        }, this);

        _.each(cfg.series, function(cfg) {
            this.addSeries(cfg);
        }, this);

    }

    function render(options) {
        var defaults = {
            hidden: false
        };

        options || (options = {});
        _.defaults(options, defaults);

        var anchors = this._anchors;
        var axes = this._axes;
        var series = this._series;

        measure.call(this);
        layout.call(this);
        coordinate.call(this);

        _.each(axes, function(axis) {
            axis.render();
        }, this);

        var numberOfBars = _.reduce(series, function(numberOfBars, sequence) {
            (sequence instanceof BarSeries) &amp;&amp; numberOfBars++;
            return numberOfBars;
        }, 0);

        var barSize, barIndex = 0, padding;
        var rangeBand;
        if(numberOfBars > 0) {
            var axis = axes[CartesianChart.POSITION.BOTTOM];
            rangeBand = axis.rangeBand() * 0.7;
            barSize = rangeBand / numberOfBars;
        }

        // reorder the rendering sequence to prevent BarSeries from covering LineSeries &amp;  LineSeries covering ScatterSeries.
        series = _.sortBy(series, function(sequence) {
            if(sequence instanceof BarSeries) return 0;
            else if(sequence instanceof LineSeries) return 1;
            else return 2;
        });

        _.each(series, function(sequence) {
            if(sequence instanceof BarSeries) {
                sequence.bar({
                    size: barSize
                });
                if(numberOfBars > 1) {
                    var dx = barSize*(barIndex + 1.5) - rangeBand;
                    d3.select(sequence.el).attr('transform', 'translate(' + dx + ',0)');
                    barIndex++;
                }
            }
            // change the z-index
            sequence.detach(); sequence.attach(anchors.canvas.node());
            sequence.render();

        }, this);

        if(this.render === render) {
            this._isRendered = true;

            this.trigger('render', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this.show();
        }

        return this;
    }

    function measure() {
        var series = this._series;
        var axes = this._axes;
        var data = this._data;

        _.each(axes, function(axis) {
            var scale = axis.scale();
            var extent = [];

            _.each(series, function(sequence) {
                var fields;
                if(sequence.xAxis()===axis) {
                    // xField does not support stacked fields.
                    fields = _.isArray(sequence.xField()) ? sequence.xField() : [sequence.xField()];
                } else if(sequence.yAxis()===axis) {
                    fields = _.isArray(sequence.yField()) ? sequence.yField() : [sequence.yField()];
                } else {
                    return;
                }
                if(axis.type()===CartesianChart.AXIS.NUMERICAL) {
                    extent = data.reduce(function(extent, item) {
                        var value = _.reduce(fields, function(sum, field){
                            var value = item[field] ? item[field]() : item.get(field);
                            value || (value = 0);
                            return sum + value;
                        }, 0);
                        extent[0] = (extent[0]===undefined) ? value : Math.min(extent[0], value);
                        extent[1] = (extent[1]===undefined) ? value : Math.max(extent[1], value);
                        return extent;
                    }, extent);
                } else if(axis.type()===CartesianChart.AXIS.TIME) {
                    // Time axes do not support stacked fields;
                    var field = _.first(fields);
                    extent = data.reduce(function(extent, item) {
                        var value = item[field] ? item[field]() : item.get(field);
                        extent[0] = extent[0] ? Math.min(extent[0], value) : value;
                        extent[1] = extent[1] ? Math.max(extent[1], value) : value;
                        return extent;
                    }, extent);
                } else {
                    // Categorical axes do not support stacked fields;
                    var field = _.first(fields);
                    extent = _.union(extent, data.map(function(item) {
                        return item[field] ? item[field]() : item.get(field);
                    }));
                }
            });
            if(axis.type()===CartesianChart.AXIS.NUMERICAL
                &amp;&amp; (axis.position()===CartesianChart.POSITION.LEFT || axis.position()===CartesianChart.POSITION.RIGHT)) {
                extent[0] = 0;
            }
            axis.domain(extent);
        });
    }

    function layout() {
        var margin = {top: PADDING*2, right: PADDING*2, bottom: PADDING*2, left: PADDING*2};
        var anchors = this._anchors;
        var axes = this._axes;
        var sizes = {};

        _.each(axes, function(axis, position) {
            var size = axis.sizing();
            if(position===CartesianChart.POSITION.LEFT||position===CartesianChart.POSITION.RIGHT) {
                margin[position.toLowerCase()] = margin[position.toLowerCase()] + size.width + PADDING;
            } else {
                margin[position.toLowerCase()] = margin[position.toLowerCase()] + size.height + PADDING;
            }
        });

        if(this.title() &amp;&amp; this.title().length>0) {
            var size = dom.sizing(anchors.title);
            margin.top = margin.top + size.height + PADDING;
            sizes.title = size;
        }

        var width = this.width() - margin.left - margin.right;
        var height = this.height() - margin.top - margin.bottom;


        anchors.canvas.attr({
            'transform': 'translate(' + margin.left + ',' + margin.top + ')'
        });

        if(this.title() &amp;&amp; this.title().length>0) {
            anchors.title.attr({
                x: margin.left + width / 2,
                y: PADDING + sizes.title.height
            });
        }

        _.each(axes, function(axis, position) {
            var node = anchors.axes[position];
            var dx, dy;
            if(position===CartesianChart.POSITION.LEFT) {
                dx = margin.left; dy = margin.top;
            } else if(position===CartesianChart.POSITION.RIGHT) {
                dx = margin.left + width; dy = margin.top;
            } else if(position===CartesianChart.POSITION.BOTTOM) {
                dx = margin.left; dy = margin.top + height;
            }
            node.attr('transform', 'translate(' + dx + ',' + dy +')');
        });

        this._margin = margin;
    }


    function title(text) {
        var anchors = this._anchors;

        if(arguments.length===0) {
            return anchors.title.text();
        }

        anchors.title.text(text);

        if(text &amp;&amp; text.length>0) {
            anchors.title.style('display', '')
        } else {
            anchors.title.style('display', 'none');
        }
    }

    function coordinate() {
        var axes = this._axes;
        var margin = this._margin;
        var series = this._series;
        var width = this.width() - margin.left - margin.right;
        var height = this.height() - margin.top - margin.bottom;

        var numberOfBars = _.reduce(series, function(numberOfBars, sequence) {
            (sequence instanceof BarSeries) &amp;&amp; numberOfBars++;
            return numberOfBars;
        }, 0);
        
        _.each(axes, function(axis) {
            var scale = axis.scale();
            var range, padding;

            if(axis.position()===CartesianChart.POSITION.BOTTOM &amp;&amp; axis.type()===CartesianChart.AXIS.NUMERICAL) {
                axis.ticks(this.data().size());
            }

            if(axis.position()===CartesianChart.POSITION.LEFT||axis.position()===CartesianChart.POSITION.RIGHT) {
                range = [height, 0];
            } else {
                range = [0, width];
            }

            if(axis.type()===CartesianChart.AXIS.CATEGORICAL) {
                padding = 1;
            } else if(numberOfBars>0 &amp;&amp; axis.position()===CartesianChart.POSITION.BOTTOM) {
                padding = 2;
            }
            scale.range(range); axis.padding(padding);
        }, this);

    }
    
    function addSeries(series) {
        series || (series = {});
        var color = this.color(this._series.length);

        var defautls = {
            type : CartesianChart.SERIES.SCATTER,
            xAxis: CartesianChart.POSITION.BOTTOM,
            yAxis: CartesianChart.POSITION.LEFT,
            style: {
                fill: color,
                stroke: color
            }
        };

        _.defaults(series, defautls);

        var anchors = this._anchors;
        var selection = anchors.canvas.append('g');

        series.el = selection.node();
        series.data = this._data;
        series.xAxis = this._axes[series.xAxis];
        series.yAxis = this._axes[series.yAxis];


        if(series.type===CartesianChart.SERIES.SCATTER) {
            this._series.push(new ScatterSeries(series));
        } else if(series.type===CartesianChart.SERIES.LINE) {
            this._series.push(new LineSeries(series));
        } else if(series.type===CartesianChart.SERIES.BAR) {
            this._series.push(new BarSeries(series));
        }

        this.isRendered() &amp;&amp; this.render();
    }

    function trendline(index) {
        var series = _.isNumber(index) ? this._series[index] : _.find(this._series, function(sequence) {
            return (sequence.title()===index);
        });

        series.trendline();
    }


    function baseline(series) {
        series || (series = {});
        var color = this.color(this._series.length);

        var defautls = {
            type : CartesianChart.SERIES.LINE,
            xAxis: CartesianChart.POSITION.BOTTOM,
            yAxis: CartesianChart.POSITION.LEFT,
            style: {
                fill: color,
                stroke: color,
                'stroke-dasharray': "20,5",
            },
            marker: {
                type: 'circle',
                r: 1
            }
        };

        _.defaults(series, defautls);

        var anchors = this._anchors;
        var selection = anchors.canvas.append('g');

        series.el = selection.node();
        series.data = this._data;
        series.xAxis = this._axes[series.xAxis];
        series.yAxis = this._axes[series.yAxis];


        if(series.type===CartesianChart.SERIES.SCATTER) {
            this._series.push(new ScatterSeries(series));
        } else if(series.type===CartesianChart.SERIES.LINE) {
            this._series.push(new LineSeries(series));
        } else if(series.type===CartesianChart.SERIES.BAR) {
            this._series.push(new BarSeries(series));
        }

        this.isRendered() &amp;&amp; this.render();
    }


    /**
     *
     * Draw the grid lines.
     *
     * @private
     * @param position
     * @param options
     * @returns {grid}
     */
    function gridline(position, options) {
        options || (options = {});
        var defaults = {
            stroke: 'grey',
            'stroke-width': '0.5px'
        };
        _.defaults(options, defaults);

        //var canvas = this.canvas();

        //canvas.selectAll('[name=' + position + '] g.tick line').attr(options);

        return this;
    }



    /**
     * Get or set the data.
     *
     * ##### Events:
     * + 'transition' - triggered after a new collection is bound. event.data => the collection.
     *
     * @memberof CartesianChart#
     * @param {Collection} items - the data.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A false value will prevent the events from being triggered.
     * @param {Boolean} [options.render=true] - A false value will prevent the chart from being rendered.
     * @returns {Collection}
     */
    function data(items, options) {
        if(!items) return this._data;

        options || (options = {});

        var defaults = {
            render: true
        };

        _.defaults(options, defaults);

        if(this._data) this.stopListening(this._data);

        this._data = items;

        this._dataset = items.toArray();

        this.listenTo(this._data, "update", _.bind(onItemsUpdate, this));

        options.render &amp;&amp; this.render();

        var event = {
            context: this,
            source: this,
            data: items
        };

        (options.silent) || this.trigger('transition', event);

        return this._data;
    }

    function onItemsUpdate() {
        this.refresh();
    }

    function refresh() {

    }

    function canvas() {
        return this._canvas;
    }

    /**
     * @override
     */
    function width(value) {
        if(!value) {
            return this.$el.outerWidth() || this.cfg().width || WIDTH;
        }

        this.$el.outerWidth(value);
    }

    /**
     * @override
     */
    function height(value) {
        if(!value) {
            return this.$el.outerHeight() || this.cfg().height || HEIGHT;
        }

        this.$el.outerHeight(value);
    }

    function color(index) {
        return this._color(index)
    }

    var props = {
        _components: undefined,
        _title: undefined,
        _data: undefined,
        _axes: undefined,
        _margin: undefined,
        _measurement: undefined,
        _color: undefined,
        tagName: 'g'

    };

    var CartesianChart = declare(Base, {
        initialize: initialize,
        render: render,
        data: data,
        title: title,
        addSeries: addSeries,
        trendline: trendline,
        baseline: baseline,
        gridline: gridline,
        height: height,
        width: width,
        color: color
    }, props);

    CartesianChart.AXIS = {
        NUMERICAL: "NUMERICAL",
        TIME: "TIME",
        CATEGORICAL: "CATEGORICAL"
    };

    CartesianChart.TICKS = {
        YEARS: "YEARS",
        MONTHS: "MONTHS",
        DAYS: "DAYS",
        HOURS: "HOURS",
        MINUTES: "MINUTES",
        WEEKS: "WEEKS"
    };

    CartesianChart.SERIES = {
        LINE: "LINE",
        SCATTER: "SCATTER",
        BAR: "BAR"
    };

    CartesianChart.POSITION = {
        LEFT: "LEFT",
        TOP: "TOP",
        BOTTOM: "BOTTOM",
        RIGHT: "RIGHT"
    };

    return CartesianChart;

});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
